Subject: bug#11034: Binutils, GDB, GCC and Automake's 'cygnus' option

From: Stefano Lattarini <[email-masked]>
Date: Wed, 28 Mar 2012 15:01:42 +0200

On 03/28/2012 02:29 PM, Joseph S. Myers wrote:
> On Wed, 28 Mar 2012, Stefano Lattarini wrote:
> 
>>   - texinfo.tex is not required if a Texinfo source file is specified. The
>>     assumption is that the file will be supplied, but in a place that
>>     Automake cannot find. This assumption is an artifact of how Cygnus
>>     packages are typically bundled.
> 
> texinfo.tex is in a known location, but only a single copy for GDB and 
> binutils and a single copy for GCC rather than in each directory needing 
> it.
>
Which makes perfect sense.  So Automake should support this use case.

> Is the approach used (for example) in libquadmath/Makefile.am
> 
> TEXINFO_TEX   = ../gcc/doc/include/texinfo.tex
> 
> considered a suitable approach for this case?
>
This would seem the most sensible approach, yes.  Want to give it a try to
see whether it works in the GCC/GDB/Binutils tree? (What should be verified
particularly carefully is that the idiom works also in VPATH builds).

>>   - Certain tools will be searched for in the build tree as well as in the
>>     user's PATH. These tools are runtest, expect, makeinfo and texi2dvi.
> 
> I did previously suggest removing the existing support for building and 
> using these tools in-tree 
> <http://gcc.gnu.org/ml/gcc-patches/2011-03/msg01674.html>, but there was 
> pushback on that.  I don't know, however, if it actually depends on 
> anything built into automake.
>
Hmm...  Couldn't the issues (if any) be worked around by explicitly
re-defining the $(EXPECT), $(RUNTEST), $(MAKEINFO) and $(TEXI2DVI)
variables in the relevant Makefiles so that they point to the bundled
tools?  E.g.,

  EXPECT = $(top_builddir)/../expect/expect

and so on.

>>   - The check target doesn't depend on all.
> 
> I'm not aware of a need for that.
> 
Glad to hear that.

Regards,
  Stefano